SystemOrganization addCategory: #'DuinoBot-EtoysCompiler'!

!DuinoBotPlayer methodsFor: '*duinobot-etoyscompiler' stamp: 'Richo 10/23/2012 12:58'!
getDuinoBotMode
	^ self costume renderedMorph mode nameSymbol! !

!DuinoBotPlayer methodsFor: '*duinobot-etoyscompiler' stamp: 'Richo 10/23/2012 13:00'!
setDuinoBotMode: aSymbol
	self getDuinoBotMode = aSymbol ifTrue: [^self].
	self costume renderedMorph
		mode: (aSymbol caseOf: {
			[#direct] -> [DuinoBotDirectMode new].
			[#compiled] -> [DuinoBotCompiledMode new].
			} otherwise: [^self]).
	self updateScriptEditors! !

!DuinoBotPlayer methodsFor: '*duinobot-etoyscompiler' stamp: 'Richo 10/23/2012 15:53'!
updateScriptEditors
	"Horrible hack below"
	World allMorphsDo: [:morph | | viewer |
		"Update scripts category of all opened viewers"
		((morph isKindOf: StandardViewer)
		and: [morph playerScripted isKindOf: self class officialClass orOf: ArduinoPlayer]) 
			ifTrue: [morph updateScriptsCategory].
		"Also update closed viewers"
		((morph isKindOf: ViewerFlapTab) and: [(viewer := morph referent findA: StandardViewer) notNil])
			ifTrue: [viewer updateScriptsCategory].
		"Finally, update all opened script editors"
		((morph isKindOf: ScriptEditorMorph)
		and: [morph playerScripted isKindOf: self class officialClass orOf: ArduinoPlayer]) 
			ifTrue: [morph replaceRow1; minWidth: nil]]! !

ArduinoPlayerTranslator subclass: #DuinoBotPlayerTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuinoBot-EtoysCompiler'!

!DuinoBotPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 10/23/2012 13:32'!
classCategory
	^ 'DuinoBotPrograms'! !

!DuinoBotPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 10/23/2012 13:49'!
classIncludes
	^ super classIncludes , #("'DuinoBot.h'")! !

!DuinoBotPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 10/23/2012 13:49'!
commonSuperclass
	^ DuinoBotSketch! !

!DuinoBotPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 10/23/2012 13:50'!
programName
	^ #DuinoBotEtoysProgram! !

!DuinoBotMorph methodsFor: '*duinobot-etoyscompiler' stamp: 'Richo 10/23/2012 13:19'!
playerTranslator
	^ DuinoBotPlayerTranslator on: self! !

ArduinoCompiledMode subclass: #DuinoBotCompiledMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuinoBot-EtoysCompiler'!
